unit FmInet1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons,Wininet, ComCtrls,Grids, IdMessage,
  IdBaseComponent, IdComponent, IdTCPConnection, IdTCPClient,
  IdMessageClient, IdSMTP, IdAntiFreezeBase, IdAntiFreeze, IdHTTP,IniFiles,
  IdSocks, IdIOHandler, IdIOHandlerSocket, ExtCtrls, ShellAPI,Zlib;


type
  TForm4 = class(TForm)
    Label1: TLabel;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    BitBtn4: TBitBtn;
    ProgressBar1: TProgressBar;
    SMTP: TIdSMTP;
    IdMsgSend: TIdMessage;
    BitBtn3: TBitBtn;
    IdAntiFreeze1: TIdAntiFreeze;
    IdHTTP1: TIdHTTP;
    stat: TLabel;
    IdIOHandlerSocket1: TIdIOHandlerSocket;
    IdSocksInfo1: TIdSocksInfo;
    Panel1: TPanel;
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure BitBtn4Click(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form4: TForm4;
  IniFile:TIniFile; //   
  implementation
uses
MainF1;
{$R *.dfm}
///   
procedure unpack(infile:string;outfile:string);
    const
buffer_size=1024;
var 

  source,dest:TFileStream; 

  decompressStream:TDecompressionStream; //

  bytesread:integer; 

  mainbuffer:array[0..1023] of char; 

begin 

  source:=TFileStream.Create(infile,fmOpenRead);

  dest:=TFileStream.Create(outfile,fmCreate);

  decompressStream:=TDecompressionStream.Create(source); // 

  try

  repeat 

   bytesread:=decompressStream.Read(mainbuffer,buffer_size);

   dest.Write(mainbuffer,bytesread); 

  until bytesread<1024; 

  except 

  decompressStream.Free; 

  source.Free; 

  dest.Free; 

  exit; 

  end; 

  decompressStream.Free; 

  source.Free; 

  dest.Free;
end;

//////   HTML
procedure SGridToHtml(SG: TStringgrid; Dest: TMemo; BorderSize: Integer);
 var
    i, p: integer;
   SStyle1, SStyle2, Text: string;
 begin
   Dest.Clear;
   Dest.Lines.Add('<html> ');
   Dest.Lines.Add('<body><b>'+kontragent+' | '+region+' | '+DateToStr(Date())+' | '+TimeToStr(Time())+'</b>');
   Dest.Lines.Add(' <table style="text-align: left; width: 100%;" border="1">');

   for i := 0 to SG.RowCount - 1 do
   begin
     Dest.Lines.Add('  <tr>');
     for p := 0 to SG.ColCount - 1 do
     begin
       SStyle1 := '';
       SStyle2 := '';
       if fsbold in SG.Font.Style then
       begin
         SStyle1 := SStyle1 + '<b>';
         SStyle2 := SStyle2 + '</b>';
       end;
       if fsitalic in SG.Font.Style then
       begin
         SStyle1 := SStyle1 + '<i>';
         SStyle2 := SStyle2 + '</i>';
       end;
       if fsunderline in SG.Font.Style then
       begin
         SStyle1 := SStyle1 + '<u>';
         SStyle2 := SStyle2 + '</u>';
       end;
       Text := sg.Cells[p, i];
       if Text = '' then Text := ' ';
       Dest.Lines.Add('    <td width="' + IntToStr(sg.ColWidths[p]) +
         '" height="' + IntToStr(sg.RowHeights[p]) +
         '"><font color="#000000" face="Arial">' + SStyle1 + Text + SStyle2 + '</font></td>');
     end;
     Dest.Lines.Add('</tr>');
   end;
   Dest.Lines.Add('  <tr><td></td><td></td><td></td><td></td><td></td><td><b>'+SumCol+'</b></td></tr></table>');
   Dest.Lines.Add('</body>');;
   Dest.Lines.Add('</html>');
 end;
 ///  
 function ExecuteAndWait(FileName: string; HideApplication: boolean): boolean;
var
  StartupInfo: TStartupInfo;
  ProcessInfo: TProcessInformation;
  exitc: cardinal;
begin
  FillChar(StartupInfo, sizeof(StartupInfo), 0);
  with StartupInfo do begin
    cb := Sizeof(StartupInfo);
    dwFlags := STARTF_USESHOWWINDOW;
    wShowWindow := SW_SHOW;
  end;
  if not CreateProcess(nil, PChar(FileName), nil, nil, false,
    CREATE_NEW_CONSOLE or NORMAL_PRIORITY_CLASS, nil, nil,
    StartupInfo, ProcessInfo) then result := false
  else begin
    if HideApplication then begin
      Application.Minimize;
      ShowWindow(Application.Handle, SW_HIDE);
      WaitforSingleObject(ProcessInfo.hProcess, INFINITE);
    end else
      while WaitforSingleObject(ProcessInfo.hProcess, 100) =
        WAIT_TIMEOUT do begin
        Application.ProcessMessages;
        if Application.Terminated
          then TerminateProcess(ProcessInfo.hProcess, 0);
      end;
    GetExitCodeProcess(ProcessInfo.hProcess, exitc);
    result := (exitc = 0);
    if HideApplication then begin
      ShowWindow(Application.Handle, SW_SHOW);
      Application.Restore;
      Application.BringToFront;
    end;
  end;
end;
///
procedure TForm4.BitBtn1Click(Sender: TObject);
label
label1;
var
fs:TFileStream;
IdHTTP: TIdHTTP;
begin
/////
IniFile := TIniFile.Create(AppDir+'settings.ini');
//     
IdHTTP := TIdHTTP.Create(Self);
if IniFile.ReadString('OptionsConnect','FlagPr','')='1' then
begin
if IniFile.ReadString('OptionsConnect','FlagPrAu','')='1' then IdHTTP.ProxyParams.BasicAuthentication:=True else IdHTTP.ProxyParams.BasicAuthentication:=False;
IdHTTP.ProxyParams.ProxyServer:=IniFile.ReadString('OptionsConnect','HostH','');
IdHTTP.ProxyParams.ProxyPort:=StrToInt(IniFile.ReadString('OptionsConnect','PortH',''));
IdHTTP.ProxyParams.ProxyUsername:=IniFile.ReadString('OptionsConnect','UnameH','');
IdHTTP.ProxyParams.ProxyPassword:=IniFile.ReadString('OptionsConnect','PassH','');
goto label1;
end
else
begin
label1:
IniFile.Free; {  ,      };
ProgressBar1.Position:=50;
stat.Visible:=True;
stat.Caption:='...';
fs:=TFileStream.Create('news.spr',fmCreate);
try
IdHTTP.Get('http://ink-service.ru/files/inkdialer/news.spr',fs);
finally
fs.Free;
end;
fs:=TFileStream.Create('dp.spr',fmCreate);
try
IdHTTP.Get('http://ink-service.ru/files/inkdialer/dp.spr',fs);
finally
fs.Free;
end;
fs:=TFileStream.Create(dbfile+'.arc',fmCreate);
try
IdHTTP.Get('http://ink-service.ru/files/inkdialer/'+dbfile+'.arc',fs);
finally
fs.Free;
end;
Form1.Query1.Close;
if FileExists(dbfile+'.dbf') then DeleteFile(dbfile+'.dbf');
    unpack(dbfile+'.arc',dbfile+'.dbf');
    stat.Visible:=False;
Form1.DataSource1.DataSet:=Form1.Query1;
Form1.DBGrid1.DataSource:=Form1.DataSource1;
Form1.DBGrid1.Columns[7].FieldName:=cprice;
 Form1.Query1.Close;
 Form1.Query1.SQL.Clear;
 Form1.Query1.SQL.Add('Select '+cCreateDate+','+cVidTovara+','+cshCod+','+cNameTovara+','+cEd+','+cOstatok+','+cprice+', Zakupka, Rezerv from '+dbfile+'.dbf ');
 Form1.Query1.Open;
 Form1.CheckBox1.Enabled:=True;
 Form1.Edit1.Enabled:=True;
 Form1.BitBtn1.Visible:=True;
 Form1.BitBtn4.Visible:=True;
 Form1.BitBtn2.Enabled:=True;
 Form1.BitBtn5.Visible:=False;
 Form1.BitBtn3.Enabled:=True;
 Form1.DbGrid1.Enabled:=True;
 Form1.StringGrid1.Enabled:=False;
ProgressBar1.Position:=100;
Form1.RichEdit1.Lines.LoadFromFile('news.spr');
ShowMessage('- !');
Form1.Timer1.Enabled:=True;
end;
end;


procedure TForm4.BitBtn2Click(Sender: TObject);
begin
ProgressBar1.Position:=0;
Close();
Form4.BitBtn4.Visible:=False;
Form4.BitBtn3.Visible:=False;
Form4.BitBtn1.Visible:=False;
end;

procedure TForm4.FormShow(Sender: TObject);

begin
Label1.Caption:=QFMI1;
end;


procedure TForm4.BitBtn4Click(Sender: TObject);
 var

   LSMTP: TIdSMTP;
   LMsg: TIdMessage;
        flag:string;

begin
   SGridToHtml(Form1.StringGrid1, Form1.Memo1, 1);
   Form1.Memo1.Lines.SaveToFile('zakaz.html');
   ProgressBar1.Position:=50;

 IniFile := TIniFile.Create(AppDir+'settings.ini');
 IniFile := TIniFile.Create(AppDir+'settings.ini');
 flag:=IniFile.ReadString('OptionsConnect','FlagAlt1','');
 IniFile.Free; {  ,      };
 if flag='1' then
 begin
      ShowMessage('  !         E-Mail: zakaz-ink-service@rambler.ru      "ZAKAZ  __"');
      ProgressBar1.Position:=0;
 end

 else begin
 LSMTP := TIdSMTP.Create(nil);
  LMsg := TIdMessage.Create(LSMTP);
  ShowMessage(' ! : FmInet1,  295');//     
    with LMsg do begin
      Date := Now;
      Subject := 'ZAKAZ';
      ReplyTo.EMailAddresses := kontragentmail;//  (  )
      Recipients.EMailAddresses := 'milo@host.ru'; //  ( )
      from.Text:='milo@host.ru'; //  ( )
      ContentType:= 'text/html';
      CharSet:= 'Windows-1251';
       Priority := mpHighest;
      Body.Add('  '+kontragent);
    end;
   TIdAttachment.Create(LMsg.MessageParts , 'zakaz.html');
     with LSMTP do begin
      AuthenticationType := atLogin;
      Host := 'smtp.host.ru'; //smtp 
      Username := 'login'; // 
      Password:= 'pass'; //
      Connect;
      try
        Send(LMsg);
        Disconnect;
    except
    on E: Exception do ShowMessage(E.Message);
      end;
    end;
    FreeAndNil(LMsg);
  FreeAndNil(LSMTP);
  ProgressBar1.Position:=100;
  ShowMessage(' !');
end;
end;
procedure TForm4.BitBtn3Click(Sender: TObject);

label
labelend;
 var

  LSMTP: TIdSMTP;
  LMsg: TIdMessage;
  flag:string;

begin
 IniFile := TIniFile.Create(AppDir+'settings.ini');
 ProgressBar1.Position:=50;
 IniFile := TIniFile.Create(AppDir+'settings.ini');
 flag:=IniFile.ReadString('OptionsConnect','FlagAlt1','1');
 IniFile.Free; {  ,      };
 if flag='1' then
 begin
 ProgressBar1.Position:=0;
      ShowMessage('  !    !      Web-   !');

 end

 else begin
   ShowMessage(' ! : FmInet1,  351');//     
  LSMTP := TIdSMTP.Create(nil);
  LMsg := TIdMessage.Create(LSMTP);
  try
    with LMsg do begin
      Date := Now;
      Subject := 'ZAYAVKA ASSORTIMENTA';
      Recipients.EMailAddresses := 'milo@host.ru';  // 
      from.Text:='milo@host.ru'; // 
      ContentType:= 'text/html';
      CharSet:= 'Windows-1251';
       Priority := mpHighest;
       Body.Add('  '+kontragent+' | '+region);
         Body.Add(': '+Form1.lborg.Text);
         Body.Add('E-mail: '+Form1.lbmail.Text);
         Body.Add(': '+Form1.lbcity.Text);
         Body.Add(': '+Form1.lbnaim.Text);
         Body.Add(': '+Form1.lbpart.Text);
         Body.Add(': '+Form1.lbproiz.Text);
         Body.Add('  : '+Form1.lbperiod.Text);
         Body.Add('    (): '+Form1.lbobem.Text);
         Body.Add(': '+Form1.reprime4.Text);
    end;
    TIdAttachment.Create(LMsg.MessageParts , 'zakaz.html');
    with LSMTP do begin
      AuthenticationType := atLogin;
      Host := 'smtp.host.ru';  //smtp 
      Username := 'login'; //
      Password:= 'pass'; // 
      Connect;
    try
        Send(LMsg);
        Disconnect;
    except
    on E: Exception do ShowMessage(E.Message);
      end;
      labelend:
        ProgressBar1.Position:=100;
        ShowMessage(' !');
        end;
    Finally
        FreeAndNil(LMsg);
        FreeAndNil(LSMTP);
   end;
end;
end;



end.
