unit FmSettings;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ComCtrls, Buttons,IniFiles, Spin;

type
  TFormSettings = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    Label1: TLabel;
    CheckBox1: TCheckBox;
    lbHostH: TLabeledEdit;
    lbPortH: TLabeledEdit;
    lbUsernameH: TLabeledEdit;
    lbPassH: TLabeledEdit;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    CheckBox2: TCheckBox;
    cbalt1: TCheckBox;
    TabSheet2: TTabSheet;
    speminusdate1: TSpinEdit;
    StaticText1: TStaticText;
    cbminusdateoff1: TCheckBox;
    Label2: TLabel;
    cbexcel1: TCheckBox;
    procedure BitBtn1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure speminusdate1Change(Sender: TObject);
    procedure cbminusdateoff1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FormSettings: TFormSettings;
    IniFile:TIniFile; //   
implementation

{$R *.dfm}
uses
MainF1;
procedure TFormSettings.BitBtn1Click(Sender: TObject);
begin
Close();
end;

procedure TFormSettings.FormShow(Sender: TObject);
begin
IniFile := TIniFile.Create(AppDir+'settings.ini');
//     
if IniFile.ReadString('OptionsConnect','FlagPr','')='1' then CheckBox1.Checked:=True else CheckBox1.Checked:=False;
if IniFile.ReadString('OptionsConnect','FlagPrAu','')='1' then CheckBox2.Checked:=True else CheckBox2.Checked:=False;
if IniFile.ReadString('OptionsConnect','FlagAlt1','')='1' then cbalt1.Checked:=True else cbalt1.Checked:=False;
if IniFile.ReadString('OptionsWork','FlagMinusDateOff','')='1' then cbminusdateoff1.Checked:=True else cbminusdateoff1.Checked:=False;
if IniFile.ReadString('OptionsWork','ExcelExportOn','')='1' then cbexcel1.Checked:=True else cbexcel1.Checked:=False;
speminusdate1.Text:=IniFile.ReadString('OptionsWork','minusdate','90');
lbHostH.Text:=IniFile.ReadString('OptionsConnect','HostH','');
lbPortH.Text:=IniFile.ReadString('OptionsConnect','PortH','');
lbUsernameH.Text:=IniFile.ReadString('OptionsConnect','UnameH','');
lbPassH.Text:=IniFile.ReadString('OptionsConnect','PassH','');


IniFile.Free; {  ,      };
if CheckBox1.Checked then cbalt1.Enabled:=False else cbalt1.Enabled:=True;
end;

procedure TFormSettings.BitBtn2Click(Sender: TObject);
begin
IniFile := TIniFile.Create(AppDir+'settings.ini');
//     
if CheckBox1.Checked then IniFile.WriteString('OptionsConnect','FlagPr','1') else IniFile.WriteString('OptionsConnect','FlagPr','0');
if CheckBox2.Checked then IniFile.WriteString('OptionsConnect','FlagPrAu','1') else IniFile.WriteString('OptionsConnect','FlagPrAu','0');
if cbalt1.Checked then IniFile.WriteString('OptionsConnect','FlagAlt1','1') else IniFile.WriteString('OptionsConnect','FlagAlt1','0');
if cbminusdateoff1.Checked then IniFile.WriteString('OptionsWork','FlagMinusDateOff','1') else IniFile.WriteString('OptionsWork','FlagMinusDateOff','0');
if cbexcel1.Checked then IniFile.WriteString('OptionsWork','ExcelExportOn','1') else IniFile.WriteString('OptionsWork','ExcelExportOn','0');
minusdate:=StrToInt(speminusdate1.Text);
IniFile.WriteString('OptionsWork','minusdate',speminusdate1.Text);
IniFile.WriteString('OptionsConnect','HostH',lbHostH.Text);
IniFile.WriteString('OptionsConnect','PortH',lbPortH.Text);
IniFile.WriteString('OptionsConnect','UnameH',lbUsernameH.Text);
IniFile.WriteString('OptionsConnect','PassH',lbPassH.Text);

IniFile.Free; {  ,      };
Close();
end;

procedure TFormSettings.CheckBox1Click(Sender: TObject);
begin
if CheckBox1.Checked then begin cbalt1.Enabled:=False; cbalt1.Checked:=True end else begin cbalt1.Enabled:=True; cbalt1.Checked:=False end;
end;

procedure TFormSettings.speminusdate1Change(Sender: TObject);
begin
if speminusdate1.Text <>'' then
begin
if StrToInt(speminusdate1.Text) < 0 then speminusdate1.Text:='0';
end
else
end;

procedure TFormSettings.cbminusdateoff1Click(Sender: TObject);
begin
if cbminusdateoff1.Checked then
begin
speminusdate1.Text:='0';
speminusdate1.Enabled:=False;
end else
begin
speminusdate1.Text:='90';
speminusdate1.Enabled:=True;
end;
end;

end.
